;***************************************************************
;	LCD t MPPT [dRg[[ v2.01
;	For PIC16F88, for 8MHz clock
;	v1.0`1.1	2009/03/16-04/09
;	v2.0		2009/04/15iVbg_EŁj
;	LF http://www.asahi-net.or.jp/~SE1M-NITU/html/mppt4.htm
;***************************************************************

	LIST		P=16F88
	INCLUDE		P16F88.INC

	ERRORLEVEL	-205
	ERRORLEVEL	-302

;	CCP1 = RB3 ɃZbg

	__CONFIG  _CONFIG1, _CP_OFF & _CCP1_RB3 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_IO

	__CONFIG  _CONFIG2, _IESO_OFF & _FCMEN_OFF

;--------------------------------------------------------------------------------
;	|[g蓖
;--------------------------------------------------------------------------------
;
;	RA0		AN IN	drdo
;	RA1		AN IN	do
;	RA2		AN IN	zdrdo
;	RA3		AN IN	VREF+ 3.98V
;	RA4		D  OUT	MPPT Enable pin, SHORT = Enable, OPEN = Disable
;	RA5		D  IN	fobOpśASHORT = fobO[h(MPP A/DlƑzdrd A/Dl\), OPEN = ʏidAd\j
;	RA6		D  OUT	ߕdx LED
;	RA7		D  OUT	א FET Rg[

;	RB0		D  OUT	LCD RS
;	RB1		D  OUT	LCD E
;	RB4		D  OUT	LCD DB4
;	RB5		D  OUT	LCD DB5
;	RB6		D  OUT	LCD DB6
;	RB7		D  OUT	LCD DB7

;	RB2		D  IN	[d LED
;	RB3		D  OUT	PWM 

;	LCD ʃC[W (16~1sj
;
;POS0     67     DEF
;   |     ||     | |
;	13.4V +1.25A M-E  MPPT [h
;         -0.23A PxL  pX[d[h
;                E N  MPPlG[
;                S G  P[d
;                  F  [d~
;                L    zdro͕s
;                C    N[_E
;
;
;--------------------------------------------------------------------------------
;	ϐAhX`
;--------------------------------------------------------------------------------

CBLOCK			 H'20'	; ϐGA擪AhX

SOLAR_V					; zdrdXgAp
BATT_V					; obedXgAp

VOLTAGE_H				; A/D ϊlʈꎞXgAp
VOLTAGE_L				; A/D ϊlʈꎞXgAp

BATT_V10_H				; drd 10bit A/D ϊl
BATT_V10_L				; drd 10bit A/D ϊl

SOLAR_V10_H				; zdrd 10bit A/D ϊl
SOLAR_V10_L				; zdrd 10bit A/D ϊl

AD_FACTOR				; A/D ϊlŊ邩̃[N

;AD1					; Defined in Math16.lib
;AD2					; Defined in Math16.lib

CURRENT_H				; d 10bit A/D ϊl x 100 
CURRENT_L				; d 10bit A/D ϊl x 100 

V1						; d ASCII ꎞi[piȉ5oCg͘Amۂ邱Ɓj
V2
V3
V4
V5

MPP_V					; MPP dXgAp
PWM_WIDTH				; e[eB[l
PWM_COUNT1				; PWM sJE^
PWM_COUNT2				; PWM sJE^

USER_FLAG				; etO
INT_COUNTER				; 񊄂荞ݏɗ̃JE^
SHUTDOWN_COUNTER		; Vbg_EpJE^

ENDC

;---------------------------------------------------------------------------

CBLOCK			H'7A'	; SoNʕϐGAɊm, 16F88 ̏ꍇ 0070H-007FH

W_WORK					; 荞ݏp[N
ST_WORK					; 荞ݏp[N
FSR_WORK				; 荞ݏp[N
EEPROM_COUNTER			; EEPROM ANZXpJE^
EEPROM_ADRS				; EEPROM AhXۑp
ENDC

;---------------------------------------------------------------------------

CBLOCK			H'A0'	; Bank 1 Ɋmۂ Bank 0 ̈ߖ

INT_WORK1				; ԑ҂JE^ޔp
INT_WORK2				; ԑ҂JE^ޔp
INT_WORK3				; ԑ҂JE^ޔp

INT_A1					; Zޔp
INT_B1					; Zޔp
INT_W1					; Zޔp
INT_Na					; Zޔp
INT_Nba					; Zޔp

ENDC

;---------------------------------------------------------------------------
; |[g`
;---------------------------------------------------------------------------

#DEFINE		INT_EVENT	D'10'		; 32ms ̊荞݉ action N

#DEFINE		CTRLTRIS	TRISA		; e I/O |[g
#DEFINE		LCDTRIS		TRISB

#DEFINE		LCDPORT		PORTB
#DEFINE		CTRLPORT	PORTA		; LCD, MPPT ȊÕRg[|[g
#DEFINE		MPPTPORT	PORTB		; MPPT Rg[|[g

#DEFINE		BAT_PORT	0
#DEFINE		CUR_PORT	1
#DEFINE		SOL_PORT	2
#DEFINE		VREF_PORT	3
#DEFINE		PWM_ENABLE	4
#DEFINE		PWSW_PORT	5
#DEFINE		ALARM_PORT	6
#DEFINE		LOAD_PORT	7

#DEFINE		POWER_PORT	2
#DEFINE		PWM_PORT	3

#DEFINE		BATTERY_IN	CTRLPORT,BAT_PORT	; drd
#DEFINE		CURRENT_IN	CTRLPORT,CUR_PORT	; d
#DEFINE		SOLAR_IN	CTRLPORT,SOL_PORT	; zdrd
#DEFINE		VREF_IN		CTRLPORT,VREF_PORT	; Od
#DEFINE		CHARGE_MODE	CTRLPORT,PWM_ENABLE	; PWM @\L/
#DEFINE		ALARM_OUT	CTRLPORT,ALARM_PORT	; ߕd LED i H = ߕd j
#DEFINE		LOAD_OUT	CTRLPORT,LOAD_PORT	; א       i H = אڑAL = א؂藣 j
#DEFINE		POWER_SW	CTRLPORT,PWSW_PORT	; d OFF SW
#DEFINE		POWER_OUT	MPPTPORT,POWER_PORT	; do
#DEFINE		PWM_OUT		MPPTPORT,PWM_PORT	; PWM PULSE o

#DEFINE		BANK0		BCF	STATUS,RP0
#DEFINE		BANK1		BSF	STATUS,RP0

#DEFINE		BAT_FULL		USER_FLAG,0	; [dtOrbg, 1 = [d
#DEFINE		BAT_EMPTY		USER_FLAG,1	; ߕdtOrbg, 1 = ߕd
#DEFINE		COOL_DOWN_DONE	USER_FLAG,2	; N[_EmFtOrbg, 1 = N[_Eς

;---------------------------------------------------------------------------
; 萔`
;---------------------------------------------------------------------------

#DEFINE		TRACK_COUNT	D'40'	; MPP ǐՃ[v񐔁iNbN 8MHz10[v1bj

								; NbN 8MHz  15KHz ݒ
;#DEFINE		PWM_CYCLE	D'149'	; PE2 WX^ݒl
;#DEFINE		DUTY100		D'150'	; DUTY 100%izdrJpj
;#DEFINE		DUTY5		D'5'	; DUTY   5%igN[dpj
;#DEFINE		WIDTH_MAX	D'145'	; DUTY ől

								; NbN 8MHz  PWM 20KHz ݒ
#DEFINE		PWM_CYCLE	D'99'	; PE2 WX^ݒl
#DEFINE		DUTY100		D'100'	; DUTY 100%
#DEFINE		DUTY5		D'5'	; DUTY   5%ipX[dpj
#DEFINE		WIDTH_MAX	D'100'	; DUTY ől

#DEFINE		WIDTH_MIN	D'1'	; DUTY ŏl

;	Vref+ = 3.98V Ƃ 60count/A
;	zdrd̕ 1/6 Ƃ
;	drd@̕ 1/6 Ƃ

#DEFINE		FULL_V		D'147'	; [d     13.8V  8bit A/D ϊl = 13.8/6 * 255/3.98
#DEFINE		RECHARGE_V	D'144'	; ď[d 13.5V  8bit A/D ϊl = 13.5/6 * 255/3.98
#DEFINE		BATT50_V	D'133'	; 50%[d    12.5V  8bit A/D ϊl = 12.5/6 * 255/3.98
#DEFINE		EMPTY_V		D'122'	; ߕd     11.5V  8bit A/D ϊl = 11.5/6 * 255/3.98
#DEFINE		SHUTDOWN_V	D'119'	; SHUTDOWN   11.2V  8bit A/D ϊl = 11.2/6 * 255/3.98

#DEFINE		V_FACTOR	D'43'	; 10bit A/D JEgdr 1V ɑ邩
;								; BAT x 1/6 ̏ꍇA12V 2.0V ƂȂ邩 1023/3.98x2/12 = 42.8
#DEFINE		S_FACTOR	D'43'	; 10bit A/D JEgőzdr 1V ɑ邩
;								; S-BAT x 1/6 ̏ꍇA12V 2.0V ƂȂ邩 1023/3.98x2/12 = 42.8
#DEFINE		C_FACTOR	D'60'	; 10bit A/D JEg 1A Bd 3.98V  60JEg/A

#DEFINE		S_CALIB		D'50'	; dZT[̃Lu[VliZT[̖ɎKvj
								; 0A ̎ 600 JEǧ덷
								; }CiXl̏ꍇ̓vO{̂̉Z␳ZɏCKv

#DEFINE		SHUTDOWN	D'20'	; Vbg_EdVbg_E邩

;--------------------------------------------------------------------------------
;	vOX^[g
;--------------------------------------------------------------------------------

	ORG		H'0'			; vOJnԒn̎w
	GOTO	INITIALIZE

;--------------------------------------------------------------------------------
;	荞ݏX^[g
;--------------------------------------------------------------------------------

	ORG		H'4'			; 荞ݏ擪AhX

	MOVWF	W_WORK			; SoNʗ̈ɃWX^QҔ
	SWAPF	STATUS,W		; Z tOeȂ悤AMOVF ł͂Ȃ SWAPF gp
	MOVWF	ST_WORK
	MOVF	FSR,W
	MOVWF	FSR_WORK

	BANK0					; I BANK 0 ɐݒB荞ݎ̃oNԂ STATUS WX^Aŕ

	DECFSZ	INT_COUNTER,F	; JE^`FbN
	GOTO	POP_REG			; 񐔂ɒBĂȂΉɊ荞ݏI

;--------------------------------------------------------------------------------
;	{
;--------------------------------------------------------------------------------

	CALL	PUSH_USR_VAR	; ϐޔ

	CALL	GET_DATA		; drdAd
	CALL	LCD_PRINT		; LCD ɕ\ (5.45ms)
	CALL	CLEAR_INT		; 荞݃JE^

	CALL	POP_USR_VAR		; ϐA

;--------------------------------------------------------------------------------
;	荞ݏI
;--------------------------------------------------------------------------------

POP_REG:					; WX^A

	MOVF	FSR_WORK,W
	MOVWF	FSR
	SWAPF	ST_WORK,W
	MOVWF	STATUS
	SWAPF	W_WORK,F
	SWAPF	W_WORK,W

	BCF		INTCON,TMR0IF	; TMR0荞݃tONAĂ
;	BCF		PIR1,TMR1IF		; TMR1荞݃tONAĂ
							; tONAĂȂƎ̊荞݂Ȃ̂Œ
	RETFIE					; 荞ݏI

;--------------------------------------------------------------------------------
;	
;--------------------------------------------------------------------------------

INITIALIZE:

	BANKSEL	PORTA			; Bank 0
	CLRF	PORTA
	CLRF	PORTB			; d͒~ԂɂȂ邪A莞 SW ÂĂ
							; vO͎sp
	BANKSEL	OSCCON
	MOVLW	B'01111100'		; NbN 8MHz ɐݒ
	MOVWF	OSCCON			; Bank 1

	CLRF	PIE1			; Bank1, 荞݂͂ЂƂ܂Sĕs

	BANKSEL	ANSEL			; Bank 1, ANSEL ݒ TRISA/B ݒOłȂ_ƂET
	CLRF	ANSEL			; S|[gfW^ɐݒ
	BSF		ANSEL,BAT_PORT	; drdo|[gAiO
	NOP
	BSF		ANSEL,CUR_PORT	; do|[gAiO
	NOP
	BSF		ANSEL,SOL_PORT	; zdrdo|[gAiO
	NOP
	BSF		ANSEL,VREF_PORT	; Od|[gAiO

	CLRF	TRISB			; Bank 1, S|[go͂
	CLRF	TRISA

	BSF		BATTERY_IN		; IN Đݒ
	NOP	
	BSF		CURRENT_IN		; IN Đݒ
	NOP
	BSF		SOLAR_IN		; IN Đݒ
	NOP
	BSF		VREF_IN			; IN Đݒ
	NOP
	BSF		CHARGE_MODE		; IN Đݒ

	BANKSEL CMCON			; Bank 0
	MOVLW	B'00000111'		; Rp[^gp
	MOVWF	CMCON

;--------------------------------------------------------------------------------
;	A/D Ro[^[ݒ (10bit)
;--------------------------------------------------------------------------------

	BANKSEL	ADCON1			; Bank 1
	MOVLW	B'10100000'		; El(10bit A/Dϊ)A32 Tosci̍ŏʃrbgj, Vref+ = AN3, Vref- = Vss
	MOVWF	ADCON1

	BANKSEL ADCON0			; Bank 0
	MOVLW	B'10000001'		; 32 Tosc, AN0 gp, AD Ro[^d ON
	MOVWF	ADCON0

;--------------------------------------------------------------------------------
;	ϐ
;--------------------------------------------------------------------------------

	CALL	CLEAR_INT		; CxgJE^
	CALL	CLEAR_SHUTDOWN	; Vbg_EJE^
	CLRF	USER_FLAG		; [U[tOSNA
	BSF		COOL_DOWN_DONE	; N[_Eς݂ɃZbg
	CLRF	MPP_V

	CALL	LCD_INI			; LCD 

	BSF		POWER_OUT		; dȋJnA`^OΉ˂āA
							; ܂ POWER ON XCb`ĂKv

	CALL	STARTUP			; Nʕ\
	CALL	READ_BATT_V		; drds擾Ă

;--------------------------------------------------------------------------------
;	TMR0 ݒ, 8MHz Œ 32ms 荞ݔJn
;--------------------------------------------------------------------------------

	BANKSEL	OPTION_REG		; Bank 1

	MOVLW	B'00000111'		; Weak pull up disable, TMR0 interanal clock, PSA = TMR0, PS = 1:256
	MOVWF	OPTION_REG

	BANKSEL	TMR0			; Bank 0
	CLRF	TMR0			; 8MHz  0.5us x 256 count x PS 256 = 32ms Ɋ荞ݔ

	BSF		INTCON,TMR0IE	; TMR0I[o[t[荞ݔ
	NOP
	BSF		INTCON,GIE		; 荞݋

;---------------------------------------------------------------------------
;	PWM ݒ ` TMR2 X^[g
;---------------------------------------------------------------------------

	BANKSEL	PR2				; Bank 1
	MOVLW	PWM_CYCLE		; PWM gǂݍ
	MOVWF	PR2				; PWM Zbg

	CLRF	PWM_WIDTH
	CLRF	CCPR1L			; l Duty 0% (=zdr؂藣j

	BANKSEL	CCP1CON			; Bank 0
	MOVLW	B'00001100'		; PWM [h ɐݒ, Duty cycle LSB = 0
	MOVWF	CCP1CON

	MOVLW	B'0000100'		; TIMER2 ON, Prescale = 1:1
	MOVWF	T2CON			; Bank 0, TIMER2 START

	CALL	LOAD_CONNECT	; ЂƂ܂אڑ

;--------------------------------------------------------------------------------
;	C[`
;--------------------------------------------------------------------------------

MAIN_LOOP:

	BTFSC	POWER_SW			; d OFF XCb`Ă L ɂȂ莟̍sXLbv
	GOTO	BATT_CHECK_START	; ʏ폈

	CALL	WAIT_25ms			; `^Oh~̂߈莞ԑ҂

	BTFSS	POWER_SW			; d OFF XCb`ȂȂ H ɂȂ莟̍sXLbv
	GOTO	EXEC_SHUTDOWN		; Vbg_Es

;---------------------------------------------------------------------------
; ߕd`FbNidrd͊荞ݏœǂށj
;---------------------------------------------------------------------------

BATT_CHECK_START:

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	EMPTY_V				; ߕd`FbN EMPTY_V - VOLTAGE -> W
	BTFSC	STATUS,C			; dȂL[ C=0 ƂȂ莟̖߂XLbv
	GOTO	OVER_DISCHARGE		; ߕd

;--------------------------------------------------------------------------------
;	drA[d ?
;--------------------------------------------------------------------------------

	CALL	CLEAR_SHUTDOWN		; @IԂł͂Ȃ̂ŃVbg_EJE^

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	FULL_V				; FULL_V - VOLTAGE -> W
	BTFSC	STATUS,C			; [d͎؂ꂪ̂ C=0 ƂȂA̖߂XLbv
	GOTO	CHECK_RECHARGE		; [dł͂Ȃ

;--------------------------------------------------------------------------------
;	[d
;--------------------------------------------------------------------------------

	CALL	DISCON_SOLAR		; zdr؂藣
	BSF		BAT_FULL			; [dtOZbg
	BCF		COOL_DOWN_DONE		; N[_EKvɃZbgBN[_E܂ŃpX[ds

	CALL	LOAD_CONNECT		; ߕdA׍Đڑ

	CALL	SET_BATT_FULL_STR	; LCD \
	CALL	SET_SPACE_STR		; LCD \

	GOTO	MAIN_LOOP			; CĊJ

;--------------------------------------------------------------------------------
;	ď[dd ?
;--------------------------------------------------------------------------------

CHECK_RECHARGE:

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	RECHARGE_V			; RECHARGE_V - VOLTAGE -> W
	BTFSC	STATUS,C			; ď[ddd΃L[ C=0 ƂȂ莟̖߂XLbv
	GOTO	CHECK_BATT50		; d͈͓B50%[d`FbN

;--------------------------------------------------------------------------------
;	ď[ddȏ̏ꍇ
;--------------------------------------------------------------------------------

	CALL	LOAD_CONNECT		; ߕdA׍Đڑ

	BTFSS	BAT_FULL			; [dtO`FbN
	GOTO	CHARGE				; [dtOĂȂꍇ͒ʏ or MPPT [d

	BTFSS	COOL_DOWN_DONE		; [dtO͗Ă邪AN[_Eς݂Ȃ玟̍sXLbv
	GOTO	COOL_DOWN			; ܂N[_EĂȂ̂ŏ[dȂ

	BTFSS	CHARGE_MODE			; MPPT LݒȂ̂Ŏ̍sXLbv
	GOTO	EXEC_PULSE_CHARGE	; MPPT ݒȂ̂ŉlɃpX[ds

	CALL	SET_SPACE_STR		; Ƃ肠[d~\ɂĂ

	CALL	DISCON_SOLAR		; zdr؂藣
	CALL	READ_SOLAR_V		; J̑zdrd擾

	MOVF	SOLAR_V,W
	SUBWF	BATT_V,W			; BATT_V - SOLAR_V
	BTFSC	STATUS,C			;  BATT_V < SOLAR_V Ȃ[dB؂ꔭ C=0 Ŏ̍sXLbv
	GOTO	MAIN_LOOP

;--------------------------------------------------------------------------------
;	pX[ds
;--------------------------------------------------------------------------------

EXEC_PULSE_CHARGE:

	CALL	SET_PULSE_STR		; pX[d[h\f[^Zbg

	CALL	DUTY_5				; f[eB[ 5% ɃZbgipX[dj

	GOTO	MAIN_LOOP

;--------------------------------------------------------------------------------
;	N[_EȂ̂ŏ[dȂ
;--------------------------------------------------------------------------------

COOL_DOWN:

	CALL	DISCON_SOLAR		; zdr؂藣

	CALL	SET_COOLING_STR		; LCD \

	CALL	WAIT_1sec			; 2b[d~
	CALL	WAIT_1sec

	GOTO	MAIN_LOOP			; CĊJ

;---------------------------------------------------------------------------
;	ߕd̏
;---------------------------------------------------------------------------

OVER_DISCHARGE:

	CALL	LOAD_DISCONNECT		; א؂藣

	CALL	SET_LOAD_DISCON_STR	; LCD \

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	SHUTDOWN_V			; SHUTDOWN_V - VOLTAGE -> W
	BTFSS	STATUS,C			; SHUTDOWN_V > BATT_V ȂL[ C=1 ƂȂ莟̖߂XLbv
	GOTO	CHARGE				; SHUTDOWN_V < BATT_V Ȃ̂ŏ[d

;---------------------------------------------------------------------------
;	Vbg_Ed̂ŃJE^`FbN
;---------------------------------------------------------------------------

	DECFSZ	SHUTDOWN_COUNTER
	GOTO	CHARGE				; ܂K񐔂ɒBĂȂ̂ŏ[d݂

;---------------------------------------------------------------------------
;	Vbg_E
;---------------------------------------------------------------------------

EXEC_SHUTDOWN:

	BCF		INTCON,GIE			; 荞݋֎~
	CLRF	PORTA				; ÔߑS|[g L 

SHUTDOWN_LOOP:

	CLRF	PORTB				; PIC d~iVbg_Ej

	GOTO	SHUTDOWN_LOOP		; [văpXR̊Sd҂

;---------------------------------------------------------------------------
;	50% [dĂ邩`FbN
;---------------------------------------------------------------------------

CHECK_BATT50:

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	BATT50_V			; BATT50_V - VOLTAGE -> W
	BTFSS	STATUS,C			; 50%[dddႯ΃L[ C=0 ƂȂ莟̖߂XLbv
	GOTO	CHARGE				; 50%ȏ

	BCF		BAT_FULL			; ȂdቺĂ̂ňȍ~S͏[dɐݒ
	BSF		COOL_DOWN_DONE		; \N[_ÊŃpX[d

;---------------------------------------------------------------------------
;	[dJn
;---------------------------------------------------------------------------

CHARGE:

	BTFSC	CHARGE_MODE			; MPPT ݒȂ玟̍sXLbv
	GOTO	COMPARE_VOLTAGE		; MPPT Bzdro̓`FbN

;---------------------------------------------------------------------------
;	ʏiVvj[d
;---------------------------------------------------------------------------

NORMAL_CHARGE:

	CALL	SET_SIMPLE_STR		; LCD \
	CALL	CONNECT_SOLAR		; zdrڑ

	GOTO	MAIN_LOOP

;---------------------------------------------------------------------------
;	zdrdƉdrdr
;---------------------------------------------------------------------------

COMPARE_VOLTAGE:

	CALL	DISCON_SOLAR		; zdr𕉉ׂ؂藣
	CALL	READ_SOLAR_V		; J̑zdrd擾

	MOVF	SOLAR_V,W
	SUBWF	BATT_V,W			; BATT_V - SOLAR_V(W) -> W
	BTFSS	STATUS,C			;  BATT_V > SOLAR_V Ȃǂ݂̂[dsB؂ꔭ C=1 Ŏ̍sXLbv
	GOTO	CALC_MPP			; MPPT 

;---------------------------------------------------------------------------
;	zdro͕sAIɒʏ[d[h
;---------------------------------------------------------------------------

	CALL	SET_LOW_STR			; [d[h\f[^Zbg
	CALL	CONNECT_SOLAR		; [dłȂĂRg[[̓dC͘d邩Ȃ̂Œʏ[d

	GOTO	MAIN_LOOP

;---------------------------------------------------------------------------
;	MPP vZ
;---------------------------------------------------------------------------

CALC_MPP:

	MOVF	SOLAR_V,W		; 鐔ilj
	MOVWF	A1
	MOVLW	D'5';			; 鐔
	MOVWF	B1

	CALL	DIV8			; 8bit ZA A1, ] B1 Ŗ߂Ă
							; MPP_V = Jd * 0.8AȂ킿Jd 1/5 ΋܂
	MOVF	A1,W			; 𓾂
	SUBWF	SOLAR_V,W		; WX^ SOLAR_V ̒l - W  = 0.8 * SOLAR_V
	BTFSS	STATUS,C		; ؂ꂪȂ΁ij C=1 ƂȂA̖߂XLbv
	GOTO	ILLEGULAR_MPP	; lُȂ̂ŋ␳

	BTFSS	STATUS,Z		; [̏ꍇ Z=1 ƂȂA̖߂XLbv
	GOTO	TRACK_MPP		; vZl͐

ILLEGULAR_MPP:

	CALL	SET_ERR_STR		; LCD ɃG[\
	GOTO	MAIN_LOOP		; ɃCɖ߂

;---------------------------------------------------------------------------
; MPP Ǐ][v
;---------------------------------------------------------------------------

TRACK_MPP:

	MOVWF	MPP_V			; MPP dXgA

	SUBWF	BATT_V,W		; BATT_V - MPP_V(W) -> W
	BTFSC	STATUS,C		;  BATT_V < MPP_V Ȃ[dB؂ꔭ C=0 Ŏ̍sXLbv
	GOTO	NORMAL_CHARGE	; MPP ł͌ቺ̂Œʏ[d

	CALL	SET_MPPT_STR	; MPPT [h\f[^Zbg

	CALL	CONNECT_SOLAR	; zdrڑiDUTY100%j
	CALL	WAIT_50us		; zdr艻

	MOVLW	TRACK_COUNT		; MPPT RA񃋁[v邩
	MOVWF	PWM_COUNT1		; PWM JE^ 1

PWM_LOOP1:

	MOVLW	D'255'
	MOVWF	PWM_COUNT2		; PWM JE^ 2

PWM_LOOP2:

;---------------------------------------------------------------------------
; POWER OFF XCb`o
;---------------------------------------------------------------------------

	BTFSC	POWER_SW			; d OFF XCb`Ă L ɂȂ莟̍sXLbv
	GOTO	COMPARE_MPP			; ʏ폈p

	CALL	WAIT_25ms			; `^Oh~̂߈莞ԑ҂

	BTFSS	POWER_SW			; d OFF XCb`ȂȂ H ɂȂ莟̍sXLbv
	GOTO	EXEC_SHUTDOWN		; Vbg_Es

;---------------------------------------------------------------------------
; MPP dQƂăf[eB[𒲐
;---------------------------------------------------------------------------

COMPARE_MPP:

	CALL	READ_SOLAR_V
	MOVF	SOLAR_V,W		; zdrdǂݏo

	SUBWF	MPP_V,W			; MPP_V - SOLOAR_V -> W

	BTFSC	STATUS,Z		; SOLAR_V <> MPP_V Ȃ Z=0 ƂȂ莟̍sXLbv
	GOTO	CONTINUE_MPPT1	; SOLAR_V = MPP_V ̗zԁB̂܂܃[vp

	BTFSS	STATUS,C		; MPP_V > SOLAR_V 葾zdrdႢƎ؂ꂪȂ̂ C=1 ƂȂA̖߂XLbv
	GOTO	SOLAR_DOWN		; MPP_V < SOLAR_V Ȃ̂őzdrd

;---------------------------------------------------------------------------
; zdrd UP @@DUTY DOWN 
;---------------------------------------------------------------------------

SOLAR_UP:

	DECF	PWM_WIDTH,F	; f[eB[ DOWN
	MOVF	PWM_WIDTH,W

	SUBLW	WIDTH_MIN	; WIDTH_MIN - PWM_WIDTH -> W
	BTFSS	STATUS,C	; WIDTH_MIN > DUTY Ȃ؂ꂪ C=1 ƂȂA̖߂XLbv
	GOTO	CHANGE_DUTY	; ͈͓Ȃ̂ł̂܂܃f[eB[ݒ

;
;	ŏf[eB[NbsO
;
	MOVLW	WIDTH_MIN	; Duty 0% ̒li萔jɍĐݒA0 ɂĂ܂ PWM ~
	MOVWF	PWM_WIDTH

	GOTO	CHANGE_DUTY	; f[eB[ݒ

;---------------------------------------------------------------------------
; zdrd DOWN @@DUTY UP 
;---------------------------------------------------------------------------

SOLAR_DOWN:

	INCF	PWM_WIDTH,F	; f[eB[ UP
	MOVF	PWM_WIDTH,W

	SUBLW	WIDTH_MAX	; WIDTH_MAX - PWM_WIDTH -> W
	BTFSC	STATUS,C	; WIDTH_MAX < DUTY Ȃ؂ꂪ C=0 ƂȂA̖߂XLbv
	GOTO	CHANGE_DUTY	; ͈͓Ȃ̂ł̂܂܃f[eB[ݒ

;
;	őf[eB[NbsO
;
	MOVLW	WIDTH_MAX	; Duty 100% ̒li萔jɍĐݒ
	MOVWF	PWM_WIDTH

CHANGE_DUTY:			; fB[eB[ύX

	MOVF	PWM_WIDTH,W
	MOVWF	CCPR1L		; Duty ύX

;---------------------------------------------------------------------------

CONTINUE_MPPT1:

	DECFSZ	PWM_COUNT2,F
	GOTO	PWM_LOOP2

	BTFSC	COOL_DOWN_DONE	; [dtO͗Ă邪A܂N[_EĂȂȂ玟̍sXLbv
	GOTO	CONTINUE_MPPT2	; N[_Eς݂Ȃ̂ MPPT p

	MOVF	BATT_V,W		; 荞ݒɑ肳ꂽdrd`FbN
	SUBLW	RECHARGE_V		; RECHARGE_V - VOLTAGE -> W
	BTFSC	STATUS,C		; RECHARGE_V < VOLTAGE_V ȂL[ C=0 ƂȂ莟̖߂XLbv
	GOTO	CONTINUE_MPPT2	; MPPT p

	BTFSS	COOL_DOWN_DONE	; MPPT 䒆 N  P ֓dオ̂ŃN[_E󋵃`FbN
	GOTO	CLOSE_MPPT		; N[_Erbg 0 Ȃ̂ŁiN[_EKvjȂ̂łЂƂ܂ MPPT I

CONTINUE_MPPT2:				; MPPT p

	DECFSZ	PWM_COUNT1,F
	GOTO	PWM_LOOP1

	GOTO	MAIN_LOOP		; MPPT I

;---------------------------------------------------------------------------

CLOSE_MPPT:					; MPPT rI

	CALL	SET_SPACE_STR	; MPPT I\f[^Zbg

	GOTO	COOL_DOWN		; MPPT IAN[_E

;---------------------------------------------------------------------------
; Tu[`Q
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
; zdrJ (DUTY 0%)
;---------------------------------------------------------------------------

DISCON_SOLAR:

	CLRF	PWM_WIDTH
	CLRF	CCPR1L		; Duty 0% ݒ, PWM ~
	CALL	WAIT_100ms	; PWM ւ̔f҂Ƒzdrd񕜑҂

	RETURN

;---------------------------------------------------------------------------
; zdr׃t (DUTY 100%)
;---------------------------------------------------------------------------

CONNECT_SOLAR:

	MOVLW	DUTY100		; Duty 100% ̒li萔jǂݏo
	MOVWF	PWM_WIDTH
	MOVWF	CCPR1L		; Duty 100% ݒ

	RETURN

;---------------------------------------------------------------------------
; [d̃pX[d (DUTY 5%)
;---------------------------------------------------------------------------

DUTY_5:

	MOVLW	DUTY5			; Duty 5%
	MOVWF	PWM_WIDTH
	MOVWF	CCPR1L			; Duty 5% ݒ

	RETURN

;--------------------------------------------------------------------------------
;	ߕdiא؂藣j
;--------------------------------------------------------------------------------

LOAD_DISCONNECT:

	BSF		BAT_EMPTY			; ߕdtO𗧂Ă
	BSF		ALARM_OUT			; LED xJn
	BCF		LOAD_OUT			; א؂藣
	BCF		BAT_FULL			; [dł͂ȂÔ߃NAĂ

	RETURN

;--------------------------------------------------------------------------------
;	אڑ
;--------------------------------------------------------------------------------

LOAD_CONNECT:

	BCF		BAT_EMPTY			; ߕdtONA
	BCF		ALARM_OUT			; LED x~
	BSF		LOAD_OUT			; אڑ

	CALL	SET_LOAD_CONNECT_STR	; LCD \

	RETURN

;--------------------------------------------------------------------------------
;	10 bit A/D ϊs
;	RETURN: VOLTAGE_H, VOLTAGE_L
;--------------------------------------------------------------------------------

READ_VOLTAGE10:

	BSF		ADCON0,GO		; GO (start) bit 𗧂Ă A/D ϊJn

WAIT_AD:

	BTFSC	ADCON0,GO		; A/D ϊI? 0 Ȃ玟XLbv
	GOTO	WAIT_AD			; ܂ϊ

	MOVF	ADRESH,W		; Bank 0, A/D ϊliʁjǂݏo
	MOVWF	VOLTAGE_H		; ɃXgA

	BANKSEL	ADRESL			; Bank 1
	MOVF	ADRESL,W		; A/D ϊliʁjǂݏo

	BANKSEL	PORTA			; Bank 0
	MOVWF	VOLTAGE_L		; ɃXgA (BANK0ɂ_ɒӁj

	RETURN

;---------------------------------------------------------------------------
; zdrd擾i10bit -> 16bit, 8bitj
; i荞ݓł͌Ă΂Ȃj
;---------------------------------------------------------------------------

READ_SOLAR_V:				; zdrd (10bit)

	BCF		INTCON,GIE		; 荞݋֎~ioN؂ւ̊荞݋֎~ƕϐޔsvƂ邽߁j

	MOVLW	B'10010001'		; AN2, A/D CONV Power ON
	MOVWF	ADCON0

;	CALL	WAIT_100us		; `l؂ւ̂Ńv`[W҂
	CALL	WAIT_50us		; `l؂ւ̂Ńv`[W҂
	CALL	READ_VOLTAGE10

	MOVF	VOLTAGE_H,W
	MOVWF	A1
	MOVWF	SOLAR_V10_H
	MOVF	VOLTAGE_L,W
	MOVWF	A2
	MOVWF	SOLAR_V10_L

	CLRF	B1
	MOVLW	D'4'			; 4 Ŋ 8 bit l𓾂
	MOVWF	B2

	CALL	DIV16			; in math16.lib

	MOVF	A2,W			; () 8 bit 𓾂
	MOVWF	SOLAR_V			; [NGAɃXgAĂ

	BSF		INTCON,GIE		; 荞݋

	RETURN

;---------------------------------------------------------------------------
; drd擾i10bit -> 16bit, and 8bitj
;---------------------------------------------------------------------------

READ_BATT_V:			; obed (10bit)

;	BCF		INTCON,GIE	; 荞݋֎~ioN؂ւ̊荞݋֎~ƕϐޔsvƂ邽߁j

	MOVLW	B'10000001'	; AN0, A/D CONV Power ON
	MOVWF	ADCON0

;	CALL	WAIT_100us	; `l؂ւ̂Ńv`[W҂
	CALL	WAIT_50us	; `l؂ւ̂Ńv`[W҂
	CALL	READ_VOLTAGE10

	MOVF	VOLTAGE_H,W
	MOVWF	BATT_V10_H	; 10bit ʂۑĂ
	MOVWF	A1
	MOVF	VOLTAGE_L,W
	MOVWF	BATT_V10_L	; 10bit ʂۑĂ
	MOVWF	A2

	CLRF	B1
	MOVLW	D'4'		; 4 Ŋ 8 bit l𓾂
	MOVWF	B2

	CALL	DIV16		; in math16.lib, returns A1A2

	MOVF	A2,W		; () 8 bit 
	MOVWF	BATT_V		; XgAĂ

;	BSF		INTCON,GIE		; 荞݋

	RETURN

;---------------------------------------------------------------------------
; dl擾i10bit -> 16bitj
;---------------------------------------------------------------------------

READ_CURRENT:			; d (10bit)

	MOVLW	B'10001001'	; AN1, A/D CONV Power ON
	MOVWF	ADCON0

;	CALL	WAIT_100us	; `l؂ւ̂Ńv`[W҂
	CALL	WAIT_50us	; `l؂ւ̂Ńv`[W҂
	CALL	READ_VOLTAGE10

;--------------------------------------------------------------------------------
;	G[l̃NbsO
;	͈: 300 + S_CALIB <= A/D <= 900 + S_CALIB
;--------------------------------------------------------------------------------

	MOVF	VOLTAGE_H,W
	MOVWF	A1			; 鐔ʃZbg
	MOVF	VOLTAGE_L,W
	MOVWF	A2			; 鐔ʃZbg

	MOVLW	H'01'
	MOVWF	B1
	MOVLW	H'2C' + S_CALIB		; 300 JEg + `bvŗL덷ԂB
	MOVWF	B2

	CALL	SUB16		; in Math16.lib, -̃NbsO

	BTFSS	STATUS,C	;  A/Dl >= 300 + 덷ijȂ؂ꂪ C=1 Ŏ̍sXLbv
	GOTO	SET_ERROR	; G[Zbg

	MOVF	VOLTAGE_H,W
	MOVWF	A1			; 鐔ʃZbg
	MOVF	VOLTAGE_L,W
	MOVWF	A2			; 鐔ʃZbg

	MOVLW	H'03'
	MOVWF	B1
	MOVLW	H'85' + S_CALIB		; 901 JEg + 덷Ԃ
	MOVWF	B2

	CALL	SUB16		; in Math16.lib, +̃NbsO

	BTFSC	STATUS,C	;  A/Dl < 901 + 덷 ijȂ؂ꂪ C=0 Ŏ̍sXLbv
	GOTO	SET_ERROR	; G[Zbg

;--------------------------------------------------------------------------------
;	A/D ϊl̏ꍇ̏
;--------------------------------------------------------------------------------

	MOVF	VOLTAGE_H,W
	MOVWF	A1
	MOVF	VOLTAGE_L,W
	MOVWF	A2

	MOVLW	H'01'
	MOVWF	B1
	MOVLW	H'2C' + S_CALIB		; 300 JEg + 덷Ԃ
	MOVWF	B2

	CALL	SUB16		; in math16.lib,  A1A2

	CLRF	B1
	MOVLW	D'100'		; _2ʂ܂œ邽100{Ă
	MOVWF	B2

	CALL	MUL16		; in math16.lib, returns 32bit A1A2B1B2
						; őł 600 x 100  16 bit Ɏ܂邽 A1A2 ͏ 0 

	MOVF	B1,W
	MOVWF	CURRENT_H	; 100{l̏ʂۑ
	MOVF	B2,W
	MOVWF	CURRENT_L	; 100{l̉ʂۑ

	RETURN

;--------------------------------------------------------------------------------
;	A/D ϊlzOȂ H'FFFF' Ԃ
;--------------------------------------------------------------------------------

SET_ERROR:

	MOVLW	H'FF'
	MOVWF	CURRENT_H
	MOVWF	CURRENT_L

	RETURN

;--------------------------------------------------------------------------------
;	drdAdl𓾂
;--------------------------------------------------------------------------------

GET_DATA:

;--------------------------------------------------------------------------------
;	drd
;--------------------------------------------------------------------------------

	CALL	READ_BATT_V			; drd擾

;--------------------------------------------------------------------------------
;	drdɂ LCD pobt@ɕZbg
;--------------------------------------------------------------------------------

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	EMPTY_V				; ߕd`FbN EMPTY_V - VOLTAGE -> W
	BTFSC	STATUS,C			; dȂL[ C=0 ƂȂ莟̖߂XLbv
	GOTO	SET_EMPTY

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	FULL_V				; FULL_V - VOLTAGE -> W
	BTFSC	STATUS,C			; [d͎؂ꂪ̂ C=0 ƂȂA̖߂XLbv
	GOTO	SET_RECHARGE		; [dł͂Ȃ

	CALL	SET_BATT_FULL_STR	; F \
	GOTO	CHECK_MODE

SET_EMPTY:

	CALL	SET_BATT_EMPTY_STR	; LCD \
	GOTO	CHECK_MODE

SET_RECHARGE:

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	RECHARGE_V			; RECHARGE_V - VOLTAGE -> W
	BTFSC	STATUS,C			; ď[ddd΃L[ C=0 ƂȂ莟̖߂XLbv
	GOTO	SET_BATT50			; d͈͓B50%[d`FbN

	CALL	SET_BATT_GOOD_STR	; G \
	GOTO	CHECK_MODE

SET_BATT50:

	MOVF	BATT_V,W			; dlǂݏo
	SUBLW	BATT50_V			; BATT50_V - VOLTAGE -> W
	BTFSS	STATUS,C			; 50%[dddႯ΃L[ C=0 ƂȂ莟̖߂XLbv
	GOTO	SET_NORMAL			; 50%ȏ

	CALL	SET_BATT_LOW_STR	; L \
	GOTO	CHECK_MODE

SET_NORMAL:

	CALL	SET_BATT_50_STR		; N ݒ

CHECK_MODE:

	MOVF	BATT_V10_H,W
	MOVWF	AD1
	MOVF	BATT_V10_L,W
	MOVWF	AD2

	MOVLW	V_FACTOR		; dϊ̕ϊWZbg
	CALL	AD2VOLT			; A/D ϊl10{ V1`5ASCIIR[hԂ

	MOVLW	POS0			; \ʒu擪
	MOVWF	FSR
	CALL	ASCII2BUFFER	; ASCII R[h\obt@

;--------------------------------------------------------------------------------
;	dl
;--------------------------------------------------------------------------------

CURRENT:

	CALL	READ_CURRENT	; dl擾

;--------------------------------------------------------------------------------
;	A/Dl`FbN
;--------------------------------------------------------------------------------

	INCFSZ	CURRENT_L,W		; G[lȂ H'FF'+10ɂȂ
	GOTO	CHK_CUR_DIR		; lBd

	INCFSZ	CURRENT_H,W		; G[lȂ H'FF'+10ɂȂ
	GOTO	CHK_CUR_DIR		; lBd

;--------------------------------------------------------------------------------
;	A/DlُBG[\ZbgĖ߂
;--------------------------------------------------------------------------------

	MOVLW	POS6
	MOVWF	FSR

	MOVLW	'O'
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'V'
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'E'
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'R'
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'-'
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'C'
	MOVWF	INDF

	RETURN

;--------------------------------------------------------------------------------
;	A/DlɖȂBdsB
;	A/Dlx100 > 30000 Ȃ[d(+)A30000 < A/Dlx100 Ȃd(-)
;	[dȂ (A/Dlx100 - 30000 ) / 60AdȂ (30000 - A/Dlx100) / 60
;--------------------------------------------------------------------------------

CHK_CUR_DIR:

	MOVF	CURRENT_H,W
	MOVWF	A1				; 鐔ʃZbg
	MOVF	CURRENT_L,W
	MOVWF	A2				; 鐔ʃZbg

	MOVLW	H'75'
	MOVWF	B1
	MOVLW	H'30'			; 300 x 100 JEgԂ
	MOVWF	B2

	CALL	SUB16			; in Math16.lib, execute A/D - (300 x 100)

	BTFSC	STATUS,C		; ADl < ( 300 x 100 ) ȂΎ؂ꂪ C=0 玟̍sXLbv
	GOTO	PLUS_CURRENT	; [d 0A 

;--------------------------------------------------------------------------------
;	dԂ̓dl, ((300 - A/D l) / 60 )
;--------------------------------------------------------------------------------

MINUS_CURRENT:

	MOVLW	'-'
	MOVWF	POS6

	MOVLW	H'75'
	MOVWF	A1
	MOVLW	H'30'			; 300 x 100 JEg
	MOVWF	A2

	MOVF	CURRENT_H,W
	MOVWF	B1				; 
	MOVF	CURRENT_L,W
	MOVWF	B2				; 

	CALL	SUB16			; in Math16.lib,  A1A2

	GOTO	CALC_CURRENT

;--------------------------------------------------------------------------------
;	[d͏[dނ荇Ăꍇ̓dl (( A/D l - 300) / 60 )
;	A1, A2 Ɋ鐔Ĕł
;--------------------------------------------------------------------------------

PLUS_CURRENT:

	MOVF	A2,W
	BTFSS	STATUS,Z		; ʂ0Ȃ Z=1 Ŏ̍sXLbv
	GOTO	PLUS_CURRENT2	; 0 ł͂Ȃ

	MOVF	A1,W
	BTFSS	STATUS,Z		; ʂ0Ȃ Z=1 Ŏ̍sXLbv
	GOTO	PLUS_CURRENT2

;--------------------------------------------------------------------------------
;	[dނ荇Ă (= 0A)
;--------------------------------------------------------------------------------

	MOVLW	' '
	MOVWF	POS6
	GOTO	CALC_CURRENT

;--------------------------------------------------------------------------------
;	[d̓dl (( A/D l - 300) / 60 )
;	A1, A2 Ɋ鐔Ĕł
;--------------------------------------------------------------------------------

PLUS_CURRENT2:

	MOVLW	'+'
	MOVWF	POS6

;--------------------------------------------------------------------------------
;	dliΒlj𕶎ɕϊ
;	A1, A2 Ɋ鐔Ĕł
;--------------------------------------------------------------------------------

CALC_CURRENT:

	CLRF	B1				; 鐔ʂ͎gpȂ
	MOVLW	C_FACTOR		; 鐔̉ʂ͊ZW
	MOVWF	B2

	CALL	DIV16			; 2ʂ܂ŋ܂ ( e.g. 5A -> 500 )

;--------------------------------------------------------------------------------
;	l 0 t߂̏ꍇAӂڏȂ̂ 0 Ɋۂ߂Ă܂
;--------------------------------------------------------------------------------

	MOVF	A1,F			; ʂ 0 ?
	BTFSS	STATUS,Z		; 0 Ȃ Z=1 Ŏ̍sXLbv
	GOTO	CALC_CURRENT2	; ʂ 0 łȂ̂ŒʏvZ

	MOVF	A2,W			; ʂ擾
	SUBLW	D'3'			; 3 -  -> W ( 3 = 30mA )
	BTFSS	STATUS,C		; 3 ȉȂ؂ꂪ C=1 ƂȂ莟̍sXLbv
	GOTO	CALC_CURRENT2	; 3 ȏゾ̂ŒʏvZ

	CLRF	A2				; ׂ덷Ȃ̂ 0 Ɋۂ߂Ă܂

	MOVLW	' '				; \
	MOVWF	POS6

;--------------------------------------------------------------------------------
;	dl𕶎ɕϊ
;--------------------------------------------------------------------------------

CALC_CURRENT2:

	MOVF	A1,W			; ʃXgA
	MOVWF	prm1b
	MOVF	A2,W			; ʃXgA
	MOVWF	prm1a

	CALL	HEX2DEC16		; in Math16.lib, BCD ϊ5̒10i
	CALL	BCD2ASCII16		; in Math16.lib,  BCD  ASCII ϊ

	MOVLW	POS7			; obt@̕\ʒuw
	MOVWF	FSR

	MOVF	prm3c,W			; 1̈
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'.'
	MOVWF	INDF
	INCF	FSR,F

	MOVF	prm3b,W			; _1
	MOVWF	INDF
	INCF	FSR,F

	MOVF	prm3a,W			; _2
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'A'
	MOVWF	INDF

	RETURN

;--------------------------------------------------------------------------------
;	A/D ϊ̐l_1ʂ𔺂2̓d(ASCII)ɕϊ
;	IN:		A/D ϊlF	AD1iʁj, AD2iʁj
;	IN:		W = A/D ϊlŊ邩
;	RETURN:	dl(ASCII)  V1,V2,V3,'.',V5,'V'i_j
;--------------------------------------------------------------------------------
AD2VOLT:

	MOVWF	AD_FACTOR		; ␳WۑĂ

	MOVF	AD1,W
	MOVWF	A1				; ʃZbg
	MOVF	AD2,W
	MOVWF	A2				; ʃZbg

	CLRF	B1				; ʃNA
	MOVLW	D'10'			; ʃZbg
	MOVWF	B2

	CALL	MUL16			; in Math16.lib,  10 {ɂB 32bit  16bit  0 m

	MOVF	B1,W
	MOVWF	A1				; A/D ϊl x 10 ̏ʃZbg

	MOVF	B2,W
	MOVWF	A2				; A/D ϊl x 10 ̉ʃZbg

	CLRF	B1				; ʂ͎gpȂ
	MOVF	AD_FACTOR,W		; ŽWǂݏo
	MOVWF	B2

	CALL	DIV16

	MOVF	A1,W			; 
	MOVWF	prm1b
	MOVF	A2,W
	MOVWF	prm1a

	CALL	HEX2DEC16		; in Math16.lib, BCD ϊ5̒10i
	CALL	BCD2ASCII16		; in Math16.lib, BCD  ASCII ϊ

	MOVLW	V1
	MOVWF	FSR				; RETURN obt@̐擪AhX

	MOVF	prm3c,W			; 10̈ʂ`FbNi͐2Ȃ̂10̈ʂ̂݃`FbN΂悢j
	SUBLW	'0'
	BTFSC	STATUS,Z		; 擪0łȂ Z=0 ƂȂ莟̍sXLbv
	GOTO	SET_SPACE

	MOVF	prm3c,W			; 1x ACII R[hǂݒ
	GOTO	AD2VOLT_2

SET_SPACE:

	MOVLW	' '				; Xy[Xɒu

AD2VOLT_2:

	MOVWF	INDF
	INCF	FSR,F

	MOVF	prm3b,W			; 1̈
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'.'
	MOVWF	INDF
	INCF	FSR,F

	MOVF	prm3a,W			; _1
	MOVWF	INDF
	INCF	FSR,F

	MOVLW	'V'
	MOVWF	INDF

	RETURN

;--------------------------------------------------------------------------------
;	dl ASCII \obt@ɏ
;	IN:		FSR = \擪ʒu
;--------------------------------------------------------------------------------

ASCII2BUFFER:

	MOVF	V1,W			; 10̈
	MOVWF	INDF
	INCF	FSR,F

	MOVF	V2,W			; 1̈
	MOVWF	INDF
	INCF	FSR,F

	MOVF	V3,W			; _
	MOVWF	INDF
	INCF	FSR,F

	MOVF	V4,W			; _
	MOVWF	INDF
	INCF	FSR,F

	MOVF	V5,W			; 'V'
	MOVWF	INDF

	RETURN

;--------------------------------------------------------------------------------
;	Vbg_EJE^̏
;--------------------------------------------------------------------------------

CLEAR_SHUTDOWN:

	MOVLW	SHUTDOWN		; Vbg_EJE^
	MOVWF	SHUTDOWN_COUNTER
	RETURN

;--------------------------------------------------------------------------------
;	荞݃JE^̏
;--------------------------------------------------------------------------------

CLEAR_INT:

	MOVLW	INT_EVENT		; 񐔂Zbg
	MOVWF	INT_COUNTER

	RETURN

;--------------------------------------------------------------------------------
;	LCD \֘A
;--------------------------------------------------------------------------------

SET_MPPT_STR:

	MOVLW	'M'			; MPPT
	MOVWF	POS13
	RETURN

SET_PULSE_STR:

	MOVLW	'P'			; PULSE
	MOVWF	POS13
	RETURN

SET_SIMPLE_STR:

	MOVLW	'S'			; SIMPLE
	MOVWF	POS13
	RETURN

SET_COOLING_STR:

	MOVLW	'C'			; COOL
	MOVWF	POS13
	RETURN

SET_LOW_STR:

	MOVLW	'L'			; NORMAL
	MOVWF	POS13
	RETURN

SET_ERR_STR:

	MOVLW	'E'			; ERROR
	MOVWF	POS13
	RETURN

SET_SPACE_STR:

	MOVLW	' '			; CHARGE STOP
	MOVWF	POS13
	RETURN

SET_BATT_EMPTY_STR:

	MOVLW	'E'			; BATTERY EMPTY VOLTAGE
	MOVWF	POS15
	RETURN

SET_BATT_LOW_STR:

	MOVLW	'L'			; BATTERY NORMAL VOLTAGE
	MOVWF	POS15
	RETURN

SET_BATT_50_STR:

	MOVLW	'N'			; BATTERY NORMAL VOLTAGE
	MOVWF	POS15
	RETURN

SET_BATT_GOOD_STR:

	MOVLW	'G'			; BATTERY GOOD VOLTAGE
	MOVWF	POS15
	RETURN

SET_BATT_FULL_STR:

	MOVLW	'F'			; BATTERY FULL VOLTAGE
	MOVWF	POS15
	RETURN

SET_LOAD_CONNECT_STR:

	MOVLW	'-'			; LOAD CONNECT
	MOVWF	POS14
	RETURN

SET_LOAD_DISCON_STR:

	MOVLW	'x'			; LOAD DISCONNECT
	MOVWF	POS14
	RETURN

;--------------------------------------------------------------------------------
;	荞ݎ̕ϐޔ
;	BANK 1 ɑޔ BANK 0 ̈ߖ
;--------------------------------------------------------------------------------

PUSH_USR_VAR:

	BANK0
	MOVF	COUNTER1,W		; ϐޔ
	BANK1
	MOVWF	INT_WORK1
	BANK0
	MOVF	COUNTER2,W
	BANK1
	MOVWF	INT_WORK2
	BANK0
	MOVF	COUNTER3,W
	BANK1
	MOVWF	INT_WORK3

	BANK0
	MOVF	A1,W
	BANK1
	MOVWF	INT_A1
	BANK0
	MOVF	B1,W
	BANK1
	MOVWF	INT_B1

	BANK0
	MOVF	W1,W
	BANK1
	MOVWF	INT_W1
	BANK0
	MOVF	Na,W
	BANK1
	MOVWF	INT_Na
	BANK0
	MOVF	Nba,W
	BANK1
	MOVWF	INT_Nba
	BANK0

	RETURN

;--------------------------------------------------------------------------------
;	荞ݎ̕ϐA
;--------------------------------------------------------------------------------

POP_USR_VAR:

	BANK1
	MOVF	INT_Nba,W
	BANK0
	MOVWF	Nba
	BANK1
	MOVF	INT_Na,W
	BANK0
	MOVWF	Na
	BANK1
	MOVF	INT_W1,W
	BANK0
	MOVWF	W1
	BANK1
	MOVF	INT_B1,W
	BANK0
	MOVWF	B1
	BANK1
	MOVF	INT_A1,W
	BANK0
	MOVWF	A1

	BANK1
	MOVF	INT_WORK3,W
	BANK0
	MOVWF	COUNTER3
	BANK1
	MOVF	INT_WORK2,W
	BANK0
	MOVWF	COUNTER2
	BANK1
	MOVF	INT_WORK1,W
	BANK0
	MOVWF	COUNTER1

	RETURN

;--------------------------------------------------------------------------------
;	Cuǂݍ
;--------------------------------------------------------------------------------

	INCLUDE		LCD_16F88.lib
	INCLUDE		Math16.lib
	INCLUDE		Time.lib

;--------------------------------------------------------------------------------
;	Nʕ\i\[Ẍʒu LCD Cu̓ǂݍ݌ł邱Ɓj
;--------------------------------------------------------------------------------

STARTUP:

	CLRF		EEPROM_ADRS			; ʃoNϐBAhX擪ɃZbg

	CALL		PRINT_EEPROM_DATA	; iAhX͎Iɐiށj
	CALL		PRINT_EEPROM_DATA

	CALL		BUFFER_CLEAR		; in LCD_16F88.lib, \obt@NA

	RETURN

;--------------------------------------------------------------------------------
;	EEPROM  1 sԂ̃f[^ LCD ɕ\
;	IN: EEPROM_ADRS = \擪AhX
;--------------------------------------------------------------------------------

PRINT_EEPROM_DATA:

	MOVLW		LCD_CHR_LEN		; \
	MOVWF		EEPROM_COUNTER	; ʃoNϐ

	MOVLW		POS0
	MOVWF		FSR				; ]AhXݒ

	BSF			STATUS,RP1		; BANK2  RP1=0, RP=0, BANK3  RP1=1, RP0=1
								; BANKSEL  RP0 삵Ȃ_ɒ
COPY_EEPROM_DATA:

	MOVF		EEPROM_ADRS,W	; AhX擾
	BCF			STATUS,RP0		; Bank 2
	MOVWF		EEADR			; ǂݏoAhXw

	BANKSEL		EECON1			; Bank 3
	BSF			STATUS,RP0
	BCF			EECON1,EEPGD	; Point to data memory
	BSF			EECON1,RD		; EE READ
	BANKSEL		EEDATA			; Bank 2
	MOVF		EEDATA,W		; W = EEDATA

	MOVWF		INDF			; ]
	INCF		FSR,F			; ]AhXJEgAbv
	INCF		EEPROM_ADRS,F	; ]AhXJEgAbv

	DECFSZ		EEPROM_COUNTER,F
	GOTO		COPY_EEPROM_DATA

	BCF			STATUS,RP0
	NOP
	BCF			STATUS,RP1		; Bank 0 ɖ߂

	CALL		LCD_PRINT		; LCD \

	CALL		WAIT_1sec

	RETURN

;--------------------------------------------------------------------------------
;	vOI
;--------------------------------------------------------------------------------

	ORG		H'2100'			; EEPROM JnԒnw

	DE	'M','P','P','T',' ','C','O','N','T','R','O','L','L','E','R',' '
	DE	'V','2','.','0','1',' ','B','Y',' ','G','R','A','N','A','D','A'

	END
